#
# UPDATE WARNING: xtables-addons 3.0 support only kernels 4.15+
#                 xtables-addons 2.0 (XTADDONS_2 branch) support kernels 3.7 - 4.14
#
# Conditional build:
%bcond_without	kernel		# kernel modules
%bcond_without	userspace	# userspace tools
%bcond_with	verbose		# verbose build (V=1)

# The goal here is to have main, userspace, package built once with
# simple release number, and only rebuild kernel packages with kernel
# version as part of release number, without the need to bump release
# with every kernel change.
%if 0%{?_pld_builder:1} && %{with kernel} && %{with userspace}
%{error:kernel and userspace cannot be built at the same time on PLD builders}
exit 1
%endif

%if %{without userspace}
# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0
%endif

%define		rel	1
%define		pname	xtables-addons
Summary:	Additional extensions for xtables packet filtering system
Summary(pl.UTF-8):	Dodatkowe rozszerzenia do systemu filtrowania pakietów xtables
Name:		%{pname}%{?_pld_builder:%{?with_kernel:-kernel}}%{_alt_kernel}
Version:	3.26
Release:	%{rel}%{?_pld_builder:%{?with_kernel:@%{_kernel_ver_str}}}
License:	GPL v2
Group:		Networking/Admin
Source0:	https://inai.de/files/xtables-addons/%{pname}-%{version}.tar.xz
# Source0-md5:	afcec8d977631d224eaf87b27d51e77d
URL:		http://xtables-addons.sourceforge.net/
BuildRequires:	autoconf >= 2.65
BuildRequires:	automake >= 1:1.11
BuildRequires:	iptables-devel >= 1.6.0
%{?with_kernel:%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-module-build >= 3:4.18.0}}
BuildRequires:	libtool >= 2:2
BuildRequires:	pkgconfig >= 1:0.9.0
BuildRequires:	rpmbuild(macros) >= 1.746
BuildRequires:	tar >= 1.22
BuildRequires:	xz
Requires:	iptables >= 1.6.0
Obsoletes:	iptables-ipp2p < 0.8.3
BuildRoot:	%{tmpdir}/%{pname}-%{version}-root-%(id -u -n)

%define		_duplicate_files_terminate_build	0

%description
xtables-addons is the proclaimed successor to patch-o-matic(-ng). It
contains extensions that were not accepted in the main
xtables/iptables package.

For the tools to work, you should install kernel modules, which could
be found in kernel*-net-xtables-addons.

%description -l pl.UTF-8
xtables-addons to następca patch-o-matic(-ng). Zawiera rozszerzenia,
które nie zostały zaakceptowane do głównego pakietu xtables/iptables.

Aby narzędzia działały należy zainstalować moduły jądra, które można
znaleźć w pakiecie kernel*-net-xtables-addons.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-net-xtables-addons\
Summary:	Kernel modules for xtables addons\
Summary(pl.UTF-8):	Moudły jądra dla rozszerzeń z pakietu xtables-addons\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
# VERSION only dependency is intentional, for allowing multiple kernel pkgs and\
# single userspace package installs.\
Requires:	%{pname} = %{version}\
Suggests:	xtables-geoip\
Conflicts:	xtables-geoip < 20090901-2\
Requires(post,postun):	/sbin/depmod\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
\
%description -n kernel%{_alt_kernel}-net-xtables-addons\
Kernel modules for xtables addons.\
\
%description -n kernel%{_alt_kernel}-net-xtables-addons -l pl.UTF-8\
Moduły jądra dla rozszerzeń z pakietu xtables-addons.\
\
%files -n kernel%{_alt_kernel}-net-xtables-addons\
%defattr(644,root,root,755)\
# restricted permissions - may contain password\
%attr(600,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/modprobe.d/xt_sysrq.conf\
/lib/modules/%{_kernel_ver}/kernel/net/netfilter/compat_xtables.ko*\
/lib/modules/%{_kernel_ver}/kernel/net/netfilter/xt_*.ko*\
\
%post -n kernel%{_alt_kernel}-net-xtables-addons\
%depmod %{_kernel_ver}\
\
%postun -n kernel%{_alt_kernel}-net-xtables-addons\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
srcdir=${PWD:-$(pwd)}\
%build_kernel_modules XA_ABSTOPSRCDIR=$srcdir -C extensions -m compat_xtables\
for drv in extensions/compat_xtables.ko extensions/{ACCOUNT/,pknock/,}xt_*.ko ; do\
%install_kernel_modules -D installed -m ${drv%.ko} -d kernel/net/netfilter\
done\
%{nil}

%{?with_kernel:%{expand:%create_kernel_packages}}

%prep
%setup -q -n %{pname}-%{version}

%build
%configure \
	--without-kbuild

%{?with_kernel:%{expand:%build_kernel_packages}}

%if %{with userspace}
%{__make} \
	V=1
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with kernel}
install -d $RPM_BUILD_ROOT/etc/modprobe.d

cp -a installed/* $RPM_BUILD_ROOT

cat <<'EOF' > $RPM_BUILD_ROOT/etc/modprobe.d/xt_sysrq.conf
# Set password at modprobe time. This file is secure if properly guarded,
# i.e only readable by root.
#options xt_SYSRQ password=cookies

# The hash algorithm can also be specified as a module option, for example,
# to use SHA-256 instead of the default SHA-1:
#options xt_SYSRQ hash=sha256
EOF
%endif

%if %{with userspace}
%{__make} -C extensions install \
	DESTDIR=$RPM_BUILD_ROOT
%{__make} install-exec-am install-man \
	DESTDIR=$RPM_BUILD_ROOT

%{__rm} $RPM_BUILD_ROOT%{_libdir}/libxt_ACCOUNT_cl.{la,so}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%if %{with userspace}
%files
%defattr(644,root,root,755)
%doc README.rst doc/{README.psd,changelog.rst}
%attr(755,root,root) %{_bindir}/xt_geoip_query
%attr(755,root,root) %{_sbindir}/iptaccount
%attr(755,root,root) %{_sbindir}/pknlusr
%attr(755,root,root) %{_libdir}/libxt_ACCOUNT_cl.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libxt_ACCOUNT_cl.so.1
%attr(755,root,root) %{_libdir}/xtables/libxt_*.so
%dir %{_libexecdir}/xtables-addons
%attr(755,root,root) %{_libexecdir}/xtables-addons/xt_asn_build
%attr(755,root,root) %{_libexecdir}/xtables-addons/xt_asn_dl
%attr(755,root,root) %{_libexecdir}/xtables-addons/xt_asn_fetch
%attr(755,root,root) %{_libexecdir}/xtables-addons/xt_geoip_build
%attr(755,root,root) %{_libexecdir}/xtables-addons/xt_geoip_build_maxmind
%attr(755,root,root) %{_libexecdir}/xtables-addons/xt_geoip_dl
%attr(755,root,root) %{_libexecdir}/xtables-addons/xt_geoip_dl_maxmind
%{_mandir}/man1/xt_asn_build.1*
%{_mandir}/man1/xt_asn_dl.1*
%{_mandir}/man1/xt_geoip_build.1*
%{_mandir}/man1/xt_geoip_build_maxmind.1*
%{_mandir}/man1/xt_geoip_dl.1*
%{_mandir}/man1/xt_geoip_dl_maxmind.1*
%{_mandir}/man1/xt_geoip_query.1*
%{_mandir}/man8/iptaccount.8*
%{_mandir}/man8/xtables-addons.8*
%{_mandir}/man8/pknlusr.8*
%endif
%changelog
* Sun Apr 28 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/xtables-addons.git;a=log;h=auto/th/xtables-addons-3.26-1

* Sat Mar 23 2024 Jakub Bogusz <qboosh@pld-linux.org> c30b761
- updated to 3.26

* Sun Dec 24 2023 Jan Rękorajski <baggins@pld-linux.org> 88fff0d
- up to 3.25

* Sat Jul 01 2023 Jakub Bogusz <qboosh@pld-linux.org> a2a7e0f
- updated to 3.24

* Sat Feb 25 2023 Jan Rękorajski <baggins@pld-linux.org> 3b34b27
- up to 3.23

* Wed Dec 21 2022 Jakub Bogusz <qboosh@pld-linux.org> f04797c
- package also userspace scripts (previously omitted from split kernel/userspace building)

* Sat Dec 17 2022 Jan Rękorajski <baggins@pld-linux.org> 8dad122
- up to 3.22

* Fri Jun 17 2022 Jan Rękorajski <baggins@pld-linux.org> 53fde45
- fix files

* Thu Jun 16 2022 Jan Rękorajski <baggins@pld-linux.org> 66affb5
- up to 3.21

* Sat Apr 02 2022 Jan Rękorajski <baggins@pld-linux.org> 2ec4ecb
- up to 3.19

* Sat Jan 15 2022 Jakub Bogusz <qboosh@pld-linux.org> ccd923f
- updated to 3.18

* Sun Nov 28 2021 Jan Rękorajski <baggins@pld-linux.org> 3530361
- Release 3 (by relup.sh)

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> 84a83e2
- rebuild with separate debuginfo build-ids

* Wed Feb 24 2021 Jan Rękorajski <baggins@pld-linux.org> f51e631
- up to 3.16

* Sun Nov 29 2020 Jan Rękorajski <baggins@pld-linux.org> 4ba041e
- up to 3.13

* Wed Oct 21 2020 Jan Rękorajski <baggins@pld-linux.org> d776018
- up to 3.11

* Sat Aug 22 2020 Jakub Bogusz <qboosh@pld-linux.org> c6204fc
- updated to 3.10 (linux 5.8 support)

* Tue Apr 14 2020 Jakub Bogusz <qboosh@pld-linux.org> 9603d03
- ensure fixed kmod-deps macros

* Sun Apr 05 2020 Jan Rękorajski <baggins@pld-linux.org> e06a9dd
- up to 3.9

* Fri Jan 31 2020 Jakub Bogusz <qboosh@pld-linux.org> b84a30a
- updated to 3.7

* Fri Nov 29 2019 Jakub Bogusz <qboosh@pld-linux.org> 65b98a0
- updated to 3.6

